/*
Core

Core API is used to manage resources around organisation like auth, set webhooks per channels, manage campaigns.

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package coreapi

import (
	"encoding/json"
	"time"
)

// checks if the Notification type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &Notification{}

// Notification struct for Notification
type Notification struct {
	Id string `json:"id"`
	UserId string `json:"user_id"`
	OrganizationId string `json:"organization_id"`
	ChannelId *string `json:"channel_id,omitempty"`
	Type string `json:"type"`
	Category NotificationCategory `json:"category"`
	Severity string `json:"severity"`
	Parameters *string `json:"parameters,omitempty"`
	Subject string `json:"subject"`
	Text string `json:"text"`
	ButtonText *string `json:"button_text,omitempty"`
	Link *string `json:"link,omitempty"`
	CreatedAt time.Time `json:"created_at"`
	ReadAt *time.Time `json:"read_at,omitempty"`
}

// NewNotification instantiates a new Notification object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewNotification(id string, userId string, organizationId string, type_ string, category NotificationCategory, severity string, subject string, text string, createdAt time.Time) *Notification {
	this := Notification{}
	this.Id = id
	this.UserId = userId
	this.OrganizationId = organizationId
	this.Type = type_
	this.Category = category
	this.Severity = severity
	this.Subject = subject
	this.Text = text
	this.CreatedAt = createdAt
	return &this
}

// NewNotificationWithDefaults instantiates a new Notification object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewNotificationWithDefaults() *Notification {
	this := Notification{}
	return &this
}

// GetId returns the Id field value
func (o *Notification) GetId() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Id
}

// GetIdOk returns a tuple with the Id field value
// and a boolean to check if the value has been set.
func (o *Notification) GetIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Id, true
}

// SetId sets field value
func (o *Notification) SetId(v string) {
	o.Id = v
}

// GetUserId returns the UserId field value
func (o *Notification) GetUserId() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.UserId
}

// GetUserIdOk returns a tuple with the UserId field value
// and a boolean to check if the value has been set.
func (o *Notification) GetUserIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.UserId, true
}

// SetUserId sets field value
func (o *Notification) SetUserId(v string) {
	o.UserId = v
}

// GetOrganizationId returns the OrganizationId field value
func (o *Notification) GetOrganizationId() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.OrganizationId
}

// GetOrganizationIdOk returns a tuple with the OrganizationId field value
// and a boolean to check if the value has been set.
func (o *Notification) GetOrganizationIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.OrganizationId, true
}

// SetOrganizationId sets field value
func (o *Notification) SetOrganizationId(v string) {
	o.OrganizationId = v
}

// GetChannelId returns the ChannelId field value if set, zero value otherwise.
func (o *Notification) GetChannelId() string {
	if o == nil || IsNil(o.ChannelId) {
		var ret string
		return ret
	}
	return *o.ChannelId
}

// GetChannelIdOk returns a tuple with the ChannelId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Notification) GetChannelIdOk() (*string, bool) {
	if o == nil || IsNil(o.ChannelId) {
		return nil, false
	}
	return o.ChannelId, true
}

// HasChannelId returns a boolean if a field has been set.
func (o *Notification) HasChannelId() bool {
	if o != nil && !IsNil(o.ChannelId) {
		return true
	}

	return false
}

// SetChannelId gets a reference to the given string and assigns it to the ChannelId field.
func (o *Notification) SetChannelId(v string) {
	o.ChannelId = &v
}

// GetType returns the Type field value
func (o *Notification) GetType() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Type
}

// GetTypeOk returns a tuple with the Type field value
// and a boolean to check if the value has been set.
func (o *Notification) GetTypeOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Type, true
}

// SetType sets field value
func (o *Notification) SetType(v string) {
	o.Type = v
}

// GetCategory returns the Category field value
func (o *Notification) GetCategory() NotificationCategory {
	if o == nil {
		var ret NotificationCategory
		return ret
	}

	return o.Category
}

// GetCategoryOk returns a tuple with the Category field value
// and a boolean to check if the value has been set.
func (o *Notification) GetCategoryOk() (*NotificationCategory, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Category, true
}

// SetCategory sets field value
func (o *Notification) SetCategory(v NotificationCategory) {
	o.Category = v
}

// GetSeverity returns the Severity field value
func (o *Notification) GetSeverity() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Severity
}

// GetSeverityOk returns a tuple with the Severity field value
// and a boolean to check if the value has been set.
func (o *Notification) GetSeverityOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Severity, true
}

// SetSeverity sets field value
func (o *Notification) SetSeverity(v string) {
	o.Severity = v
}

// GetParameters returns the Parameters field value if set, zero value otherwise.
func (o *Notification) GetParameters() string {
	if o == nil || IsNil(o.Parameters) {
		var ret string
		return ret
	}
	return *o.Parameters
}

// GetParametersOk returns a tuple with the Parameters field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Notification) GetParametersOk() (*string, bool) {
	if o == nil || IsNil(o.Parameters) {
		return nil, false
	}
	return o.Parameters, true
}

// HasParameters returns a boolean if a field has been set.
func (o *Notification) HasParameters() bool {
	if o != nil && !IsNil(o.Parameters) {
		return true
	}

	return false
}

// SetParameters gets a reference to the given string and assigns it to the Parameters field.
func (o *Notification) SetParameters(v string) {
	o.Parameters = &v
}

// GetSubject returns the Subject field value
func (o *Notification) GetSubject() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Subject
}

// GetSubjectOk returns a tuple with the Subject field value
// and a boolean to check if the value has been set.
func (o *Notification) GetSubjectOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Subject, true
}

// SetSubject sets field value
func (o *Notification) SetSubject(v string) {
	o.Subject = v
}

// GetText returns the Text field value
func (o *Notification) GetText() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Text
}

// GetTextOk returns a tuple with the Text field value
// and a boolean to check if the value has been set.
func (o *Notification) GetTextOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Text, true
}

// SetText sets field value
func (o *Notification) SetText(v string) {
	o.Text = v
}

// GetButtonText returns the ButtonText field value if set, zero value otherwise.
func (o *Notification) GetButtonText() string {
	if o == nil || IsNil(o.ButtonText) {
		var ret string
		return ret
	}
	return *o.ButtonText
}

// GetButtonTextOk returns a tuple with the ButtonText field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Notification) GetButtonTextOk() (*string, bool) {
	if o == nil || IsNil(o.ButtonText) {
		return nil, false
	}
	return o.ButtonText, true
}

// HasButtonText returns a boolean if a field has been set.
func (o *Notification) HasButtonText() bool {
	if o != nil && !IsNil(o.ButtonText) {
		return true
	}

	return false
}

// SetButtonText gets a reference to the given string and assigns it to the ButtonText field.
func (o *Notification) SetButtonText(v string) {
	o.ButtonText = &v
}

// GetLink returns the Link field value if set, zero value otherwise.
func (o *Notification) GetLink() string {
	if o == nil || IsNil(o.Link) {
		var ret string
		return ret
	}
	return *o.Link
}

// GetLinkOk returns a tuple with the Link field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Notification) GetLinkOk() (*string, bool) {
	if o == nil || IsNil(o.Link) {
		return nil, false
	}
	return o.Link, true
}

// HasLink returns a boolean if a field has been set.
func (o *Notification) HasLink() bool {
	if o != nil && !IsNil(o.Link) {
		return true
	}

	return false
}

// SetLink gets a reference to the given string and assigns it to the Link field.
func (o *Notification) SetLink(v string) {
	o.Link = &v
}

// GetCreatedAt returns the CreatedAt field value
func (o *Notification) GetCreatedAt() time.Time {
	if o == nil {
		var ret time.Time
		return ret
	}

	return o.CreatedAt
}

// GetCreatedAtOk returns a tuple with the CreatedAt field value
// and a boolean to check if the value has been set.
func (o *Notification) GetCreatedAtOk() (*time.Time, bool) {
	if o == nil {
		return nil, false
	}
	return &o.CreatedAt, true
}

// SetCreatedAt sets field value
func (o *Notification) SetCreatedAt(v time.Time) {
	o.CreatedAt = v
}

// GetReadAt returns the ReadAt field value if set, zero value otherwise.
func (o *Notification) GetReadAt() time.Time {
	if o == nil || IsNil(o.ReadAt) {
		var ret time.Time
		return ret
	}
	return *o.ReadAt
}

// GetReadAtOk returns a tuple with the ReadAt field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Notification) GetReadAtOk() (*time.Time, bool) {
	if o == nil || IsNil(o.ReadAt) {
		return nil, false
	}
	return o.ReadAt, true
}

// HasReadAt returns a boolean if a field has been set.
func (o *Notification) HasReadAt() bool {
	if o != nil && !IsNil(o.ReadAt) {
		return true
	}

	return false
}

// SetReadAt gets a reference to the given time.Time and assigns it to the ReadAt field.
func (o *Notification) SetReadAt(v time.Time) {
	o.ReadAt = &v
}

func (o Notification) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o Notification) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	toSerialize["id"] = o.Id
	toSerialize["user_id"] = o.UserId
	toSerialize["organization_id"] = o.OrganizationId
	if !IsNil(o.ChannelId) {
		toSerialize["channel_id"] = o.ChannelId
	}
	toSerialize["type"] = o.Type
	toSerialize["category"] = o.Category
	toSerialize["severity"] = o.Severity
	if !IsNil(o.Parameters) {
		toSerialize["parameters"] = o.Parameters
	}
	toSerialize["subject"] = o.Subject
	toSerialize["text"] = o.Text
	if !IsNil(o.ButtonText) {
		toSerialize["button_text"] = o.ButtonText
	}
	if !IsNil(o.Link) {
		toSerialize["link"] = o.Link
	}
	toSerialize["created_at"] = o.CreatedAt
	if !IsNil(o.ReadAt) {
		toSerialize["read_at"] = o.ReadAt
	}
	return toSerialize, nil
}

type NullableNotification struct {
	value *Notification
	isSet bool
}

func (v NullableNotification) Get() *Notification {
	return v.value
}

func (v *NullableNotification) Set(val *Notification) {
	v.value = val
	v.isSet = true
}

func (v NullableNotification) IsSet() bool {
	return v.isSet
}

func (v *NullableNotification) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableNotification(val *Notification) *NullableNotification {
	return &NullableNotification{value: val, isSet: true}
}

func (v NullableNotification) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableNotification) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


